/**
 * Created by Locke on 15/5/27.
 */
var HDSDK = {};
// HDSDK.ApiURL = "http://tiger.hodogame.com/index.php?r=";
HDSDK.ApiURL = "https://api.hdg123.cn/index.php?r=";
HDSDK.Ipv6ApiURL = "https://ipv6api.hdg123.cn/index.php?r=";
HDSDK.debug = true;
HDSDK.tapEvent = 'click';

// 载入初始化信息
window.addEventListener('load', function () {window.location.href = 'hodo://RegisterAll'});

/*
 HDSDK.game_id = window.SDK_BASEINFO.appid;
 HDSDK.package_id = window.SDK_BASEINFO.channel_id;
 HDSDK.access_token = HDSDK.getValue('AccessToken');
 HDSDK.S = window.SDK_S;
 */


HDSDK.init = function (callback) {
  $(function () {setTimeout(callback, 100)});
};

/**
 * 打印日志
 * @param msg
 */
HDSDK.log = function (msg) {
  if (HDSDK.debug) _pLog(msg);
};

/**
 * log
 */
function log () {
  HDSDK.request('log/log_treatment', {
    from_webview : 'default'
  }, function () {});
}



/**
 * api请求
 * @param api 接口
 * @param params 参数
 * @param callback 成功回调
 * @param error_callback 失败回调，如果没有设置的话，则会默认弹窗显示网络错误
 */


function call_ajax(api_url,params,callback,error_callback) {//封装请求
    HDSDK.getAppValue('access_token', function (access_token) {
        if(access_token) params.access_token = access_token;
        HDSDK.log(JSON.stringify(params));
        $.loading();
        $.ajax({
            type: 'GET',
            url: api_url,
            data: params,
            dataType: 'json',
            complete : function () {
                isAjaxResult = false;
                $.loading();
            },
            success: function (data) {

                ajaxResult = data;
                if (isAjaxResult) {
                    callback(data);
                } else if (data.code == 1) {
                    callback(data.result);
                } else {
                    if(!error_callback) $.showModal(data.message);
                    else error_callback(data.message);
                }
            },
            error: function (xhr, type) {
                if (!error_callback) {
                    HDSDK.log(xhr);
                    HDSDK.log(type);
                    $.showModal('网络错误!');
                } else {
                    error_callback(xhr, type);
                }
            }
        });

    }, undefined);
}


HDSDK.request = function (api, params, callback, error_callback) {
  //var api_url = HDSDK.ApiURL + api;
    var api_url;

    HDSDK.getAppValue('network_init',function(network_type) {
        if(typeof(network_type)!="undefined" && network_type == 'appstore') {
            api_url = HDSDK.Ipv6ApiURL + api;

            //var params = data;
            params.game_id = window.SDK_BASEINFO.appid;
            params.package_id = window.SDK_BASEINFO.channel_id;
            params.s = window.SDK_S;

            call_ajax(api_url,params,callback, error_callback);
        } else {
            api_url = HDSDK.ApiURL + api;

            //var params = data;
            params.game_id = window.SDK_BASEINFO.appid;
            params.package_id = window.SDK_BASEINFO.channel_id;
            params.s = window.SDK_S;

            call_ajax(api_url,params,callback, error_callback);
        }
    });
};

/**
 * 弹出错误信息
 * @param message
 */
HDSDK.errorDialog = function (message) {
  $.showModal(message);
};

HDSDK.getVersion = function (url, callback) {
  $.getScript(url, function () {
    if(typeof callback == 'function') callback();
  }).error(function (xhr, type) {
    callback();
  })
};

HDSDK.updateVersion = function (callback) {
  if($.system() == 'ios') {
    $.getScript("js/version.js?" + new Date().getTime(), function() {
      updateTMP(callback);
    }).error(function (xhr, type) {
      updateTMP(callback);
    })
  } else updateTMP(callback);
};

function updateTMP (callback) {
  var oldVersion = VERSION;
    var host_url;


    HDSDK.getAppValue('network_init',function(network_type) {
        if(typeof(network_type)!="undefined" && network_type == 'appstore') {
            host_url = 'https://ipv6cache.hdg123.cn/templates';
        } else {
            host_url = 'https://cache.hdg123.cn';
        }
    });


  HDSDK.getVersion(host_url + '/templates/' + get('Template') + '/js/version.js', function () {
    set('lastUpdate', new Date().getTime());
    var newVersion = VERSION;
    if(oldVersion < newVersion) {
      clearTimeout(timer);
      $.showModal('正在更新中......');
      _SDK('UpdateCache', [get('Template')], function (rep) {
        // _SDK('Reload') 强制刷新
        rep.success && _SDK('Reload');
      });
    } else callback();
  });
}

/**
 * 返回App变量
 * @param name 变量名
 * @param callback 返回的回调函数
 * @param defValue 如果返回的是空置的话，返回默认值
 */
HDSDK.getAppValue = function (name, callback, defValue) {
  _GetAppValue(name, function (data) {
    if (data && JSON.stringify(data) != '{}') {
      callback(data);
    } else {
      callback(defValue || undefined);
    }
  });
};

/**
 * 设置App变量
 * @param name
 * @param value
 */
HDSDK.setAppValue = function (name, value) {
  _SetAppValue(name, value);
};

/**
 * 返回SD卡中的变量
 * @param name 变量名
 * @param callback 返回的回调函数
 * @param defValue 如果返回的是空置的话，返回默认值
 */
HDSDK.getSDValue = function (name, callback, defValue) {
  _GetSDValue(name, function (data) {
    if (data) {
      callback(data);
    } else {
      callback(defValue);
    }
  });
};

/**
 * 设置SD卡中的变量
 * @param name
 * @param value
 */
HDSDK.setSDValue = function (name, value) {
  _SetSDValue(name, value);
};

/**
 * 无回调直接获取App中的变量
 * @param name
 * @param defValue
 */
HDSDK.getValue = function (name, defValue) {
  var data = _GetValue(name);
  if (data && JSON.stringify(data) != '{}') {
    return data;
  }
  return defValue || undefined;

};

/**
 * 关闭窗口
 */
HDSDK.closeWindow = function (remove) {
  if(remove==undefined){
    remove = _GetValue('WindowRemove');
  }
  if (remove) {
    _SDK('Remove');
    return;
  }
  _SDK('Close');
};

/**
 * 开新窗口
 * @param url URL 打开网址
 * @param name 窗口名称，可选，不设置的话，会随机产生名字，关闭的时候也会自动移除
 * @param params 开新窗口的时候初始化的App变量，可以通过getAppValue取得
 */
HDSDK.open = function (url, name, params) {
  params = params || {};
  if (!name) {
    name = 'W_' + (new Date).getTime();
    params.WindowRemove = true; //这种随机名称窗口，标记一个初始化变量，Close关闭方法的时候会根据这个变量来决定是移除窗口还是隐藏窗口
  }
  if(url.substr(0,4).toLowerCase() != 'http'){
    var curr_url = window.location.href;
    if(url.substr(0,1) == '/'){
      url = url.substr(1);
    }

    url = curr_url.substr(0,curr_url.lastIndexOf('/')) +'/'+ url;
  }
  _SDK('OpenWindow', [name, url, params]);
};

/**
 * 后退到前一个窗口，如果没有前一个窗口，则自动关闭
 */
HDSDK.back = function(){
  setTimeout(function () {
    HDSDK.closeWindow(true);
    _SDK('Back');
  }, 1);
};

/**
 * 浮动图标
 * @param show
 */
HDSDK.floatIcon = function(show){
  show = show?'show':'hide';
  _SDK('FloatIcon', [show]);
};
