/**
 * Created by Locke on 15/5/28.
 */

/*if(window.init) {
  window._Init = function () {
    $(init);
  };
  $(init);
}*/

/**
 *
 * @type {{email: RegExp, phone: RegExp}}
 */
var regexp = {
  email : /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/,
  phone : /1[3-8]+\d{9}/
}, type = '', phoneEmail, ajaxResult, VERSION, isAjaxResult = false, isCountdown = false;

/**
 * 获取字符串附带的值
 * @param  {[type]} url 字符串
 * @return {[type]}     返回值json
 */
$.split = function (url) {
  var json = {}, temp;
  url = !url ? window.location.href : url;
  url = url.split('?')[1];
  if(!url) return json;
  url = url.split('&');
  $.each(url, function (index, value){
    temp = value.split('=');
    json[temp[0]] = temp[1];
  });
  return json;
};

$(function () {
  /**
   * 基础信息
   */
  $.baseinfo = window.SDK_BASEINFO;
});


/**
 * 返回键操作
 * @private
 */
function _Back() {
  var $modal = $('.modal');
  if($modal.attr('aria-hidden') == 'false') {
    $modal.modal('hide');
    return;
  }
  var $panel = $('.panel.active'), data = $panel.data();
  if(data && data.back) {
    if(data.back = 'panel') $(data.target).panel();
    else window[data.back]();
  } else if(data.callback) {
    goToGame(data.callback);
  //} else HDSDK.back();
  } else {
    HDSDK.back();
  }
}

/**
 * 系统判断
 * @returns {string} android | ios
 */
$.system = function () {
  var u = navigator.userAgent.toLowerCase(), result = 'android';
  $.each(["iphone","ipad", "ipod"], function (index, value) {
    if(u.indexOf(value) > -1) {
      result = 'ios';
      return false;
    }
  });
  return result;
};

$.autoLogin = function () {
  HDSDK.getAppValue('access_token', function (access_token) {
    HDSDK.request('auth/checkaccesstoken', {
      access_token: access_token
    }, function (rep) {
      $.each(['access_token', 'game_id', 'gameuserid', 'sessionid', 'username'], function (index, value) {
        set(value, rep[value]);
      });
      goToGame('Login', rep);
    });
  });
};

/**
 * 验证验证码
 */
function validateCode (reset_key, callback) {
  HDSDK.request('user/checkresetkey', {
    type : 'phone',
    resetkey : reset_key
  }, function (rep) {
    callback && callback(rep);
  })
}

/**
 * 根据类型发送验证码
 */
function sendCode (callback, noPhoneEmail) {
  if(type == 'phone') sendPhoneCode(callback, noPhoneEmail);
  else sendEmailCode(callback, noPhoneEmail)
}

/**
 * 发送邮箱验证码
 * @returns {boolean}
 */
function sendEmailCode(callback, noPhoneEmail) {
  if(!noPhoneEmail) {
    getEmail(function (rep) {
      if(!rep.email) {
        $.showModal('你没有绑定邮箱, 不能执行该操作!');
        return false;
      } else if(rep.email != phoneEmail) {
        $.showModal('你输入的邮箱与绑定邮箱不一样!');
        return false;
      }
      emailCodeCallback(callback);
    });
  } else {
    emailCodeCallback(callback);
  }
}

function  emailCodeCallback (callback) {
  emailCode(phoneEmail, function () {
    callback && callback();
    $.showModal('验证码发送成功!');
    $('body').countdown();
  });
}

/**
 * 发送手机验证码
 * @returns {boolean}
 */
function sendPhoneCode(callback, noPhoneEmail) {
  if(!noPhoneEmail) {
    getPhone(function(rep){
      if(!rep.phone) {
        $.showModal('你没有绑定手机, 不能执行该操作!');
        return false;
      } else if(rep.phone != phoneEmail) {
        $.showModal('你输入的手机与绑定手机不一样!');
        return false;
      }
      phoneCodeCallback(callback);
    });
  } else {
    phoneCodeCallback(callback);
  }
}
function  phoneCodeCallback (callback) {
  phoneCode(phoneEmail, function () {
    callback && callback();
    $.showModal('验证码发送成功!');
    $('body').countdown();
  });
}

function verification () {
  phoneEmail = $('.phoneEmail').val();
  if(!$.trim(phoneEmail)) {
    $.showModal('请输入你要绑定的手机!');
    return false;
  }
  type = judgeType(phoneEmail);
  if(!type) {
    $.showModal('请输入正确格式的手机!');
    return false;
  }
  return true;
}

/**
 * 发送邮箱验证码
 * @param email 邮箱地址
 * @param callback 回调
 */
function emailCode (email, callback) {
  HDSDK.request('user/emailresetkey', {email : email}, callback);
}

/**
 * 发送手机验证码
 * @param phone 手机号码
 * @param callback 回调
 */
function phoneCode (phone, callback) {
  HDSDK.request('user/phoneresetkey', {phone : phone}, callback);
}

/**
 * 倒计时插件
 */
$.fn.countdown = function () {
  if(isCountdown) return;
  var options = $(this).data();
  if(typeof options != 'object') {
    options.seconds = Number(arguments[0]) - 1;
  } else options = arguments[0];

  var $this = $(this),
  defaults = {
    countdown : $this.find('[role="countdown"]'),
    resend : $this.find('[role="resend"]'),
    $seconds : $this.find('[role="seconds"]'),
    seconds : 59
  },
  timer,
  o = $.extend({}, defaults, options);
  o.resend.hide();
  o.countdown.show();
  isCountdown = true;
  timer = setInterval(function () {
    if(o.seconds == 0) {
      o.resend.show();
      o.countdown.hide();
      o.$seconds.html(60);
      clearInterval(timer);
      isCountdown = false;
      return true;
    }
    o.$seconds.html(o.seconds);
    o.seconds--;
  }, 1000);
};

/**
 * 判断数据类型 phone or email
 * @param value
 * @returns {string}
 */
function judgeType (value) {
  var type = '';
   if(regexp.email.test(value)) type = 'email';
  // else
  if(regexp.phone.test(value)) type = 'phone';
  return type;
}

/**
 * 回到游戏
 * @param name 名称 Login, Order, UserCenter, ''
 * @param rep 数据
 */
function goToGame (name, rep) {
  rep = rep || {};
  name && _Listener(name, rep);
  HDSDK.closeWindow(true);
}

!function ($) {

  // 读取$loading
  var $loading = $('.ajaxLoading');

  // loading
  $.loading = function () {
    if($loading.hasClass('in')) {
      $loading.removeClass('in').one($.support.transition.end, function () {
        $loading.hide();
      });
      setTimeout(function () {
        $loading.hide();
      }, 150);
    } else {
      $loading.show().scrollTop(0).addClass('in');
    }
  };
}(jQuery);

/**
 * 调用模态框
 * @param body 内容
 * @param method 方法
 */
$.showModal = function (body, method) {
  var $modal = $('.modal'),
  $body = $modal.find('.modal-body');

  method = method || function () {};

  $body.html(body);
  $modal.one('hidden.bs.modal', function () {
    method();
    $('.modal-backdrop ').remove();
  });
  $modal.modal();
};

/**
 * 获取存储在app中的值
 * @param name 名称
 */
function get (name) {
  return HDSDK.getValue(name);
}

/**
 * 获取存储在sd卡中的值
 * @param name
 * @param callback
 */
function getSD (name, callback) {
  HDSDK.getSDValue(name, callback);
}

/**
 * 从app获取一个json
 * @param name 数组名称
 * @returns {*|json} 返回一个数组
 */
function getJson (name) {
  if(typeof get(name) == 'object') return get(name);
  if(get(name)) return $.parseJSON(get(name));
  return {};
}

/**
 * 设置一个值存储在app中
 * @param name 名称
 * @param value 值
 */
function set (name, value) {
  HDSDK.setAppValue(name, value);
}

/**
 * 设置一个值存储在SD卡中
 * @param name 名称
 * @param value 值
 */
function setSD (name, value) {
  HDSDK.setSDValue(name, value);
}

function getSD (name, callback) {
  HDSDK.getSDValue(name, callback);
}

/**
 * 保存json到app
 * @param name 名称
 * @param value 子值
 * @param index 子值索引
 */
function setJson (name, index, value) {
  var array = getJson(name);
  array[index] = value;
  set(name, array);
}

// 获取绑定手机
function getPhone (callback) {
  if(isByName) return HDSDK.request('user/callphonenumbyusername', {username : forgotName}, callback);
  else return HDSDK.request('user/callphonenum',{}, callback);
}

// 获取绑定邮箱
function getEmail (callback) {
  if(isByName) return HDSDK.request('user/callphonenumbyusername', {username : forgotName}, callback);
  else return HDSDK.request('user/callphonenum',{}, callback);
}

!function ($) {
  /**
   * 模块展示
   */
  $.fn.panel = function () {
    $(this)
    .fadeIn()
    .addClass('active')
    .siblings('.active')
    .hide()
    .removeClass('active');
  };

  $(document).on(HDSDK.tapEvent, '[data-toggle="panel"]', function () {
    var data = $(this).data(), $target = $(data.target);
    $target.panel();
  });
}(jQuery);

!function ($) {

  /**
   * 开新窗口
   */
  $.open = function (name) {
    HDSDK.open(name + '.html', name);
  };

  $(document).on(HDSDK.tapEvent, '[data-toggle="open"]', function () {
    var data = $(this).data(), name = data.target;
    $.open(name);
  })
}(jQuery);

!function ($) {
  /**
   * 返回上一个窗口
   */
  $.back = function (options) {
    if(options && options.target) goToGame(options.target, {});
    else HDSDK.back();
  };
  $(document).on(HDSDK.tapEvent, '[data-toggle="back"]', function () {
    var data = $(this).data();
    $.back(data);
  })
}(jQuery);

!function ($) {
  /**
   * 关闭窗口
   * @param boolean true|关闭, false|隐藏
   */
  $(document).on(HDSDK.tapEvent, '[data-toggle="close"]', function () {
    /*var $this = $(this), options = $this.data();
    if(options.callback) goToGame(options.callback);
    else HDSDK.closeWindow(true);*/
    _Back();
  });
}(jQuery);

!function ($) {
  /**
   * 执行函数
   * @param name 函数名, 必须在window下
   */
  $(document).on(HDSDK.tapEvent, '[data-toggle="function"]', function () {
    var data = $(this).data(), name = data.target;
    $.isFunction(window[name]) && window[name]();
  });
}(jQuery);

/**
 * 分页
 * @param page 当前页
 * @param allpage 总页数
 * @param callback 回调
 */
!function ($) {
  $.fn.pagination = function (page, allpage, callback) {
    var options = {};
    if ($.isNumeric(page)) {
      options.page = page;
      options.allPage = allpage;
      options.success = callback;
    } else options = arguments[0];

    var defaults = {
      page: 1,
      allPage: 10,
      isFL: false,
      firstTxt: '&le;',
      firstClass: 'pagination-first',
      lastTxt: '&ge;',
      lastClass: 'pagination-last',
      isPN: true,
      prevTxt: '&laquo;',
      prevClass: 'pagination-prev',
      nextTxt: '&raquo;',
      nextClass: 'pagination-next',
      btnNum: 5,
      btnClass: 'pagination-num',
      activeClass: 'active',
      disableClass: 'disabled',
      success: function () {},
      init: function () {},
      createBtn: function (className, string) {
        return '<li class="' + className + '"><a href="javascript:;">' + string + '</a></li>';
      }
    },
    html = '',
    _this = this,
    $this = $(this),
    o = $.extend({}, defaults, $this.data(), options);

    if (o.page == 0 || o.allPage == 0) return;

    this.createBtn = function (className, string) {
      html += o.createBtn(className, string);
    };

    if (o.isFL) _this.createBtn(o.firstClass + ' ' + (o.page == 1 ? o.disableClass : ''), o.firstTxt);
    if (o.isPN) _this.createBtn(o.prevClass + ' ' + (o.page == 1 ? o.disableClass : ''), o.prevTxt);

    if (o.page <= Math.ceil(o.btnNum / 2)) for (var i = 1; i <= o.allPage && i <= o.btnNum; i++) _this.createBtn((o.page == i ? (o.activeClass + ' ' + o.disableClass) : o.btnClass), i);
    else if (o.page > Math.ceil(o.btnNum / 2) && o.page < o.allPage - Math.floor(o.btnNum / 2)) for (var i = 1, j = o.page - Math.floor(o.btnNum / 2); i <= o.btnNum; i++, j++) _this.createBtn((o.page == j ? (o.activeClass + ' ' + o.disableClass) : o.btnClass), j);
    else for (var i = 1; i <= o.btnNum; i++) _this.createBtn((o.page == o.allPage - o.btnNum + i ? (o.activeClass + ' ' + o.disableClass) : o.btnClass), (o.allPage - o.btnNum + i));

    if (o.isPN) _this.createBtn(o.nextClass + ' ' + (o.page == o.allPage ? o.disableClass : ''), o.nextTxt);
    if (o.isFL) _this.createBtn(o.lastClass + ' ' + (o.page == o.allPage ? o.disableClass : ''), o.lastTxt);

    $this.html(html);

    this.judge = function (className, number) {
      $this.children('.' + className).click(function () {
        if ($(this).hasClass(o.disableClass)) return;
        o.success(number);
      });
    };

    _this.judge(o.firstClass, 1);
    _this.judge(o.lastClass, o.allPage);
    _this.judge(o.prevClass, o.page - 1);
    _this.judge(o.nextClass, o.page + 1);

    $this.children('.' + o.btnClass).click(function () {
      o.success($(this).text());
    });

    o.init();
  };
}(jQuery);
